//+------------------------------------------------------------------+
//|                                                    ProstoSAR.mq4 |
//|                                                     FORTRADER.RU |
//|                                              http://FORTRADER.RU |
//+------------------------------------------------------------------+
#property copyright "FORTRADER.RU"
#property link      "http://FORTRADER.RU"

extern int       TP=5;
extern int       SL=1000;
extern double Lots=3.88;


extern double step=0.002;
extern double maximum=0.03;

extern int workbars=0;
extern int magik=999999;

   int start()
   {
  
   op();
   ap();
   ip();

   return(0);
   }

/******************************************************************************************/
   int op()
   {int l,o;
   double sar= iSAR(NULL,0,step,maximum,workbars);
   
   l=chekposlimit(1); o=chekposstop(1);
   if(l!=1 && o!=1 && sar>Close[0]){OrderSend(Symbol(),OP_BUYSTOP,Lots,NormalizeDouble(sar,4),3,sar-SL*Point,sar+TP*Point,"FORTRADER.RU",magik);}
   l=chekposlimit(2); o=chekposstop(2);
   if(l!=2 && o!=2 && sar<Close[0]){OrderSend(Symbol(),OP_SELLSTOP,Lots,NormalizeDouble(sar,4),3,sar+SL*Point,sar-TP*Point,"FORTRADER.RU",magik);}

   return(0);
   }

   int  ap()
   {double sl,tp;int i;
    double pb=iSAR(NULL,0,step,maximum,workbars);
 
     for(  i=1; i<=OrdersTotal(); i++)       
     {
      if (OrderSelect(i-1,SELECT_BY_POS)==true) 
      {                 
       if(OrderType()==OP_BUYSTOP && NormalizeDouble(pb,4)<NormalizeDouble(OrderOpenPrice(),4) && OrderSymbol()==Symbol())
       { 
        OrderModify( OrderTicket(), NormalizeDouble(pb,4),NormalizeDouble(pb-SL*Point,4), NormalizeDouble(pb+TP*Point,4),0);
       }
      }
     }
     
    return(0); 
   }
   
   int  ip()
   {double sl,tp;int i;
    double pb=iSAR(NULL,0,step,maximum,workbars);
 
     for(  i=1; i<=OrdersTotal(); i++)       
     { 
      if (OrderSelect(i-1,SELECT_BY_POS)==true) 
      { 
       if(OrderType()==OP_SELLSTOP && NormalizeDouble(pb,4)>NormalizeDouble(OrderOpenPrice(),4) && OrderSymbol()==Symbol())
       {
       OrderModify( OrderTicket(), NormalizeDouble(pb,4), NormalizeDouble(pb+SL*Point,4), NormalizeDouble(pb-TP*Point,4),0);
       }
      }
     }
     
    return(0); 
   }
   
   
   int chekposlimit(int type)
   {
      for(int i=1; i<=OrdersTotal(); i++)          
      {
         if(OrderSelect(i-1,SELECT_BY_POS)==true) 
         {
           if( OrderType()==OP_BUYSTOP && OrderSymbol()==Symbol() && type==1) {return(1);}
           if( OrderType()==OP_SELLSTOP && OrderSymbol()==Symbol()  && type==2){return(2);}
         }
       }
   return(0);
   }
   
   int chekposstop(int type)
   {
      for(int i=1; i<=OrdersTotal(); i++)          
      {
       if(OrderSelect(i-1,SELECT_BY_POS)==true) 
       {
         if( OrderType()==OP_BUY  && OrderSymbol()==Symbol()  && type==1)  {return(1);}
         if( OrderType()==OP_SELL && OrderSymbol()==Symbol()  && type==2){return(2);}
       }
      }
   return(0);
   }